<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/Options.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_options_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Options.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;Options.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;boost/program_options.hpp&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">namespace </span>siggen</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;{</div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">    8</a></span>&#160;        ParseConfigResult <a class="code" href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">Options::ParseCommandLine</a> (<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[])</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        {</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;            <span class="keyword">namespace </span>opts = boost::program_options;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;            <span class="keywordflow">try</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;            {</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;                opts::options_description desc(<span class="stringliteral">&quot;Allowed options&quot;</span>);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;                desc.add_options()</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;                    (<span class="stringliteral">&quot;input,i&quot;</span>, opts::value(&amp;m_InputFileName), <span class="stringliteral">&quot;input file&quot;</span>)</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;                    (<span class="stringliteral">&quot;output,o&quot;</span>, opts::value(&amp;m_OutputFileName), <span class="stringliteral">&quot;output file with checksums&quot;</span>)</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;                    (<span class="stringliteral">&quot;block,b&quot;</span>, opts::value(&amp;m_BlockSize)-&gt;default_value(m_BlockSizeDefault), <span class="stringliteral">&quot;block size&quot;</span>)</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;                    (<span class="stringliteral">&quot;sigfun,s&quot;</span>, opts::value(&amp;m_HashName)-&gt;default_value(<span class="stringliteral">&quot;md5&quot;</span>), <span class="stringliteral">&quot;signature function&quot;</span>)</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;                    (<span class="stringliteral">&quot;policy,p&quot;</span>, opts::value(&amp;m_ThreadPolicy)-&gt;default_value(m_ThreadPolicy), <span class="stringliteral">&quot;threading policy, 0 (single thread), 1 (power saver), 2 (eager)&quot;</span>)</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;                    (<span class="stringliteral">&quot;threads,t&quot;</span>, opts::value(&amp;m_ThreadCount), <span class="stringliteral">&quot;number of threads to be used, 0 = auto&quot;</span>)</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;                    (<span class="stringliteral">&quot;debug,d&quot;</span>, opts::value(&amp;m_LogLevel)-&gt;default_value(3), <span class="stringliteral">&quot;debug level, 0 (less debug) to 5 (more debug)&quot;</span>)</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;                    (<span class="stringliteral">&quot;help,h&quot;</span>, <span class="stringliteral">&quot;print help message&quot;</span>)</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;                ;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;                opts::variables_map vars;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;                opts::store(opts::parse_command_line(argc, argv, desc), vars);</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;                opts::notify(vars);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                <span class="keywordflow">if</span> (vars.count(<span class="stringliteral">&quot;help&quot;</span>))</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                    std::cout &lt;&lt; desc &lt;&lt; std::endl;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                    <span class="keywordflow">return</span> ParseConfigResult::QuitOnHelp;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                }</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                <span class="keywordflow">if</span> (vars.count(<span class="stringliteral">&quot;input&quot;</span>) == 0)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                {</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                    <span class="keywordflow">throw</span> std::runtime_error(std::string(<span class="stringliteral">&quot;missing -input argument&quot;</span>));</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                }</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                <span class="keywordflow">if</span> (vars.count(<span class="stringliteral">&quot;output&quot;</span>) == 0)</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                    <span class="comment">// @TODO: create default from --input</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;                    <span class="keywordflow">throw</span> std::runtime_error(std::string(<span class="stringliteral">&quot;missing -output argument&quot;</span>));</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;                }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                <span class="keywordflow">if</span> (m_BlockSize == 0)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                    <span class="keywordflow">throw</span> std::runtime_error(std::string(<span class="stringliteral">&quot;block size has zero length&quot;</span>));</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;                }</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;                <span class="keywordflow">if</span> (m_ThreadPolicy == SingleThread &amp;&amp; m_ThreadCount &gt; 0)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                {</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                    <span class="keywordflow">throw</span> std::runtime_error(std::string(<span class="stringliteral">&quot;conflicting arguments: -p0 and nonzero -t&quot;</span>));</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                }</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            }</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="keywordflow">catch</span> (std::exception <span class="keyword">const</span> &amp; e)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            {</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                std::cerr &lt;&lt; <span class="stringliteral">&quot;Cannot parse command line, reason: &quot;</span> &lt;&lt; e.what() &lt;&lt; std::endl;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;                <span class="keywordflow">throw</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="keywordflow">return</span> ParseConfigResult::OK;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        }</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_options_html_ab4f252a399a19ddfc05a35984859b15d"><div class="ttname"><a href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">siggen::Options::ParseCommandLine</a></div><div class="ttdeci">ParseConfigResult ParseCommandLine(int argc, char *argv[])</div><div class="ttdoc">reads options from command line</div><div class="ttdef"><b>Definition:</b> <a href="_options_8cpp_source.html#l00008">Options.cpp:8</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>Options.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
